/*
 * A CTL parser.
 * The memory file.
 *
 *----
 * To my angel,
 * december 2001.
 *----
 * This file is in the public domain.
 */

#include "mem.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stddef.h>

void oom(void)
{
  fprintf(stdout, "%s:%d:%s: Out of memory, sorry...\n", __FILE__, __LINE__, __FUNCTION__);
  fflush(stdout);
  fflush(stderr);
  exit(1);
}

void crash(void *p)
{
  if (!p) {
    fprintf(stderr, "Out of memory, sorry.\n");
    fflush(stdout);
    fflush(stderr);
    abort();
  }
}

void *getmem(int s)
{
  //void *p = malloc(s+1000);
  void *p = malloc(s);

  crash(p);

  return p;
}

void *regetmem(void *p, int ns)
{
  //if (!p)
    //return getmem(ns);

  //p = realloc(p, ns+1000);
  p = realloc(p, ns);

  crash(p);

  return p;
}

/* you know what ? strdup is not c99 */
char *mystrdup(char *s)
{
  size_t l = strlen(s) + 1;
  char *p = malloc(l);

  crash(p);

  memcpy(p, s, l);

  return p;
}
