/*
 * Robber
 * ICFP 2005
 * Drunk Sed Team
 * http://sed.free.fr/icfp2005
 */

#ifndef _STRATEGY_H_
#define _STRATEGY_H_

void init_distances(void);
void move(void);

typedef unsigned char node_type;

#define FOOT    1
#define CAR     2

#define MAX_NODES 256
#define NB_BANKS 6
#define NB_COPS 5

#include "vars.h"

extern variables vars;
extern int nb_nodes;
extern node_type edges[MAX_NODES][MAX_NODES];
extern node_type hq;
extern node_type bank[NB_BANKS];
extern int money[NB_BANKS];
extern int my_money;
extern node_type robber;
/* if cop[i] > 0, cop by foot, if cop[i] < 0, cop by car */
extern int cop[NB_COPS];

#endif /* _STRATEGY_H_ */
